]> git.proxmox.com Git - mirror_ubuntu-bionic-kernel.git/blob - scripts/kconfig/Makefile
s390/crypto: Fix return code checking in cbc_paes_crypt()
[mirror_ubuntu-bionic-kernel.git] / scripts / kconfig / Makefile
1 # SPDX-License-Identifier: GPL-2.0
2 # ===========================================================================
3 # Kernel configuration targets
4 # These targets are used from top-level makefile
5
6 PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
7 localmodconfig localyesconfig
8
9 ifdef KBUILD_KCONFIG
10 Kconfig := $(KBUILD_KCONFIG)
11 else
12 Kconfig := Kconfig
13 endif
14
15 ifeq ($(quiet),silent_)
16 silent := -s
17 endif
18
19 # We need this, in case the user has it in its environment
20 unexport CONFIG_
21
22 xconfig: $(obj)/qconf
23 $< $(silent) $(Kconfig)
24
25 gconfig: $(obj)/gconf
26 $< $(silent) $(Kconfig)
27
28 menuconfig: $(obj)/mconf
29 $< $(silent) $(Kconfig)
30
31 config: $(obj)/conf
32 $< $(silent) --oldaskconfig $(Kconfig)
33
34 nconfig: $(obj)/nconf
35 $< $(silent) $(Kconfig)
36
37 silentoldconfig: $(obj)/conf
38 $(Q)mkdir -p include/config include/generated
39 $(Q)test -e include/generated/autoksyms.h || \
40 touch include/generated/autoksyms.h
41 $< $(silent) --$@ $(Kconfig)
42
43 localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
44 $(Q)mkdir -p include/config include/generated
45 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
46 $(Q)if [ -f .config ]; then \
47 cmp -s .tmp.config .config || \
48 (mv -f .config .config.old.1; \
49 mv -f .tmp.config .config; \
50 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
51 mv -f .config.old.1 .config.old) \
52 else \
53 mv -f .tmp.config .config; \
54 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
55 fi
56 $(Q)rm -f .tmp.config
57
58 # Create new linux.pot file
59 # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
60 update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
61 $(Q)$(kecho) " GEN config.pot"
62 $(Q)xgettext --default-domain=linux \
63 --add-comments --keyword=_ --keyword=N_ \
64 --from-code=UTF-8 \
65 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
66 --directory=$(srctree) --directory=$(objtree) \
67 --output $(obj)/config.pot
68 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
69 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
70 $(srctree)/arch/*/um/Kconfig`; \
71 do \
72 $(kecho) " GEN $$i"; \
73 $(obj)/kxgettext $$i \
74 >> $(obj)/config.pot; \
75 done )
76 $(Q)$(kecho) " GEN linux.pot"
77 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
78 --output $(obj)/linux.pot
79 $(Q)rm -f $(obj)/config.pot
80
81 # These targets map 1:1 to the commandline options of 'conf'
82 simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
83 alldefconfig randconfig listnewconfig olddefconfig
84 PHONY += $(simple-targets)
85
86 $(simple-targets): $(obj)/conf
87 $< $(silent) --$@ $(Kconfig)
88
89 PHONY += oldnoconfig savedefconfig defconfig
90
91 # oldnoconfig is an alias of olddefconfig, because people already are dependent
92 # on its behavior (sets new symbols to their default value but not 'n') with the
93 # counter-intuitive name.
94 oldnoconfig: olddefconfig
95
96 savedefconfig: $(obj)/conf
97 $< $(silent) --$@=defconfig $(Kconfig)
98
99 defconfig: $(obj)/conf
100 ifeq ($(KBUILD_DEFCONFIG),)
101 $< $(silent) --defconfig $(Kconfig)
102 else
103 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
104 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
105 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
106 else
107 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
108 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
109 endif
110 endif
111
112 %_defconfig: $(obj)/conf
113 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
114
115 configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
116
117 %.config: $(obj)/conf
118 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
119 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
120 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
121
122 PHONY += kvmconfig
123 kvmconfig: kvm_guest.config
124 @:
125
126 PHONY += xenconfig
127 xenconfig: xen.config
128 @:
129
130 PHONY += tinyconfig
131 tinyconfig:
132 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
133
134 # Help text used by make help
135 help:
136 @echo ' config - Update current config utilising a line-oriented program'
137 @echo ' nconfig - Update current config utilising a ncurses menu based'
138 @echo ' program'
139 @echo ' menuconfig - Update current config utilising a menu based program'
140 @echo ' xconfig - Update current config utilising a Qt based front-end'
141 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
142 @echo ' oldconfig - Update current config utilising a provided .config as base'
143 @echo ' localmodconfig - Update current config disabling modules not loaded'
144 @echo ' localyesconfig - Update current config converting local mods to core'
145 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
146 @echo ' defconfig - New config with default from ARCH supplied defconfig'
147 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
148 @echo ' allnoconfig - New config where all options are answered with no'
149 @echo ' allyesconfig - New config where all options are accepted with yes'
150 @echo ' allmodconfig - New config selecting modules when possible'
151 @echo ' alldefconfig - New config with all symbols set to default'
152 @echo ' randconfig - New config with random answer to all options'
153 @echo ' listnewconfig - List new options'
154 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
155 @echo ' default value'
156 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
157 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
158 @echo ' tinyconfig - Configure the tiniest possible kernel'
159
160 # lxdialog stuff
161 check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
162
163 # Use recursively expanded variables so we do not call gcc unless
164 # we really need to do so. (Do not call gcc as part of make mrproper)
165 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
166 -DLOCALE
167
168 # ===========================================================================
169 # Shared Makefile for the various kconfig executables:
170 # conf: Used for defconfig, oldconfig and related targets
171 # nconf: Used for the nconfig target.
172 # Utilizes ncurses
173 # mconf: Used for the menuconfig target
174 # Utilizes the lxdialog package
175 # qconf: Used for the xconfig target
176 # Based on Qt which needs to be installed to compile it
177 # gconf: Used for the gconfig target
178 # Based on GTK+ which needs to be installed to compile it
179 # object files used by all kconfig flavours
180
181 lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
182 lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
183
184 conf-objs := conf.o zconf.tab.o
185 mconf-objs := mconf.o zconf.tab.o $(lxdialog)
186 nconf-objs := nconf.o zconf.tab.o nconf.gui.o
187 kxgettext-objs := kxgettext.o zconf.tab.o
188 qconf-cxxobjs := qconf.o
189 qconf-objs := zconf.tab.o
190 gconf-objs := gconf.o zconf.tab.o
191
192 hostprogs-y := conf nconf mconf kxgettext qconf gconf
193
194 clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
195 clean-files += zconf.tab.c zconf.lex.c gconf.glade.h
196 clean-files += config.pot linux.pot
197
198 # Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
199 PHONY += $(obj)/dochecklxdialog
200 $(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
201 $(obj)/dochecklxdialog:
202 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
203
204 always := dochecklxdialog
205
206 # Add environment specific flags
207 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
208
209 # generated files seem to need this to find local include files
210 HOSTCFLAGS_zconf.lex.o := -I$(src)
211 HOSTCFLAGS_zconf.tab.o := -I$(src)
212
213 LEX_PREFIX_zconf := zconf
214 YACC_PREFIX_zconf := zconf
215
216 HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
217 HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
218
219 HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
220 HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
221 -Wno-missing-prototypes
222
223 HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
224
225 HOSTLOADLIBES_nconf = $(shell \
226 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
227 || pkg-config --libs menu panel ncurses 2>/dev/null \
228 || echo "-lmenu -lpanel -lncurses" )
229 $(obj)/qconf.o: $(obj)/.tmp_qtcheck
230
231 ifeq ($(MAKECMDGOALS),xconfig)
232 $(obj)/.tmp_qtcheck: $(src)/Makefile
233 -include $(obj)/.tmp_qtcheck
234
235 # Qt needs some extra effort...
236 $(obj)/.tmp_qtcheck:
237 @set -e; $(kecho) " CHECK qt"; \
238 if pkg-config --exists Qt5Core; then \
239 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
240 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
241 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
242 elif pkg-config --exists QtCore; then \
243 cflags=`pkg-config --cflags QtCore QtGui`; \
244 libs=`pkg-config --libs QtCore QtGui`; \
245 moc=`pkg-config --variable=moc_location QtCore`; \
246 else \
247 echo >&2 "*"; \
248 echo >&2 "* Could not find Qt via pkg-config."; \
249 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
250 echo >&2 "*"; \
251 exit 1; \
252 fi; \
253 echo "KC_QT_CFLAGS=$$cflags" > $@; \
254 echo "KC_QT_LIBS=$$libs" >> $@; \
255 echo "KC_QT_MOC=$$moc" >> $@
256 endif
257
258 $(obj)/gconf.o: $(obj)/.tmp_gtkcheck
259
260 ifeq ($(MAKECMDGOALS),gconfig)
261 -include $(obj)/.tmp_gtkcheck
262
263 # GTK+ needs some extra effort, too...
264 $(obj)/.tmp_gtkcheck:
265 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
266 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
267 touch $@; \
268 else \
269 echo >&2 "*"; \
270 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
271 echo >&2 "*"; \
272 false; \
273 fi \
274 else \
275 echo >&2 "*"; \
276 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
277 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
278 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
279 echo >&2 "*"; \
280 false; \
281 fi
282 endif
283
284 $(obj)/zconf.tab.o: $(obj)/zconf.lex.c
285
286 $(obj)/qconf.o: $(obj)/qconf.moc
287
288 quiet_cmd_moc = MOC $@
289 cmd_moc = $(KC_QT_MOC) -i $< -o $@
290
291 $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
292 $(call cmd,moc)
293
294 # Extract gconf menu items for i18n support
295 $(obj)/gconf.glade.h: $(obj)/gconf.glade
296 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
297 $(obj)/gconf.glade